{=======================================================================================================================

  Comming Library.

     EhLib  .

========================================================================================================================

  :

  28.06.2013 [*] EhLib v6.1.
  29.12.2012 [*] SortMarkingChanged:   .
  19.03.2007 [+]  .
  09.09.1998 [!]  Comming Library.

========================================================================================================================
  Copyright 19982013 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: CommingAddEh.pas,v 1.2 2017/08/26 08:41:49 tsk Exp $
=======================================================================================================================}
unit CommingAddEh;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Grids, DBGrids, Math, DB, ADODB,
      // EH:
      ToolCtrlsEh, DBGridEh,
      // Comming:
      CommingColor, CommingOther;

      function  EHGridEmptyRow( Grid: TDBGridEh ): Integer;
      procedure SortMarkingChanged( Grid: TDBGridEh );
      procedure EHGridHeightBinding( Grid: TDBGridEh; Par: TControl );

  type
    TGridHack = class(TDBGridEh);

implementation
//======================================================================================================================
function EHGridEmptyRow( Grid: TDBGridEh ): Integer;
  var C: Integer;
      R: Integer;
begin
  with TGridHack(Grid) do begin
    R := DefaultRowHeight + iif( dgRowLines in Options, GridLineWidth, 0 ); //   .
    C := iif( dgTitles in Options, RowHeights[0], 0 );                      // 
    if FooterRowCount > 0 then C := C + ( R * FooterRowCount ) + 1;         // 
    Result := (( ClientHeight - C ) mod R ) - 1;
  end;
end;
//======================================================================================================================
procedure EHGridHeightBinding( Grid: TDBGridEh; Par: TControl );
begin
  Par.Height := Par.Height - EHGridEmptyRow( Grid );
end;
//======================================================================================================================
procedure SortMarkingChanged( Grid: TDBGridEh);
  var i: Integer;
      s: String;
      b: TBookmark;
begin
  Screen.Cursor := crHourGlass;
  with Grid do begin
    b := DataSource.DataSet.GetBookmark;
    s := '';
    for i := 0 to SortMarkedColumns.Count - 1 do begin
      if Empty( SortMarkedColumns[i].EditMask )
        then s := s + SortMarkedColumns[i].FieldName
        else s := s + SortMarkedColumns[i].EditMask;
      if ( SortMarkedColumns[i].Title.SortMarker = smUpEh )
        then s := s + ' DESC';
      s := s + ';';
    end;
    TADODataSet(DataSource.DataSet).IndexFieldNames := s;
    DataSource.DataSet.GotoBookmark( b );
  end;
  Screen.Cursor := crDefault;
end;
//======================================================================================================================
end.
