{=======================================================================================================================

  Comming Library

      .

========================================================================================================================

  :

  15.08.2020 [+] FieldAddClipboard:      .
  02.08.2019 [+] SubStringChar:    .
  04.04.2019 [*] PosLast:   D7.
  03.04.2019 [+] StringListPos:      .
             [+] PosLast:     .
             [+] StringListAddList:    .
  24.03.2019 [+] ClearInternetChar:      Internet.
  24.10.2018 [*] ComboBoxItemSave:     .
             [+] IncludeDataString:      .
  08.09.2018 [+] CutLeftStringSubStr:      ;
  21.06.2018 [*] AddStringFromClipboard:     .
  04.11.2017 [*] ComboBoxItemSave:   .
  23.08.2017 [*] DataStringIndex.
             [-] CutDataString.
  22.08.2017 [+] StringListEmptyDelete.
  18.08.2017 [*]    .
  15.08.2017 [+] IsDataString, CutDataString, CutDataStringIndex:     .
  10.04.2017 [+] GetBracketless:   .
  26.04.2016 [+] StrToHex:  .
  12.01.2016 [+] SwapLanguage:     .
  21.12.2015 [+] CutStringChar:    .
  11.09.2015 [+] AddStringFromClipboard.
  18.04.2015 [+] PutStringIntoClipBoard, GetStringFromClipboard.
  13.04.2015 [*] UpperFirstLetterWord:  .
  28.03.2015 [*] ComboBoxItemSave:    .
  26.03.2015 [+] ComboBoxItemSave:   TComboBox    .
  11.11.2014 [+] ReplaceQuotation:    .
  17.09.2014 [+] LeftStringDelete:     .
             [*] ReplaceQuotation:      .
             [!]   D7  XE.
  16.09.2014 [!]  Comming D7  XE.
  14.09.2014 [+] ParolOscillator:  .
  09.11.2013 [*] ReplaceQuotation:    - .
  07.05.2013 [+] ReplaceBracket:    .
             [*] QuotationReplace  ReplaceQuotation.
  12.03.2013 [+] PosAfter:      .
  11.11.2012 [-] Replicate.  System.StringOfChar.
  05.11.2012 [*] DelDoubleChar:     .
  25.10.2012 [+] HTMLDeleteComments, HTMLDeleteTag, HTMLReplaceSymbol -  HTML.
  23.10.2012 [+] UpperFirstLetterSentence:  ,   .
  24.03.2012 [-]  FloatToSQL  CommingADO.
  02.03.2012 [+] StrToHex, HexToStr:  .
  11.02.2012 [+]    ('Object'ID).
  09.02.2012 [!]    Delphi XE2.
  29.01.2012 [*] UpperFirstLetterWord:     .
             [-] ReplaceStr:  StringReplace  unit StrUtils.
             [+] QuotationReplace:       .
  08.12.2011 [*] UpperFirstLetterWord:    "-".
  23.09.2010 [*] StringListTrimUpperFirstLetter:   .
  22.09.2010 [+] StringListTrimUpperFirstLetter:     .
  24.07.2010 [+] TransRusLatinFamily:      394  30.06.98.
  30.01.2010 [+] PosChar:      .
  07.10.2009 [-] RightString:  StrUtils.RightStr.
  24.07.2008 [*] TildeToAscii:  .
  25.09.2008 [+] CutLeftString:   .
  17.05.2008 [+] TransLatinRus:  .
  26.10.2007 [-] StdWordDelims:   ,   .
  22.05.2007 [*]   StringListTrim, StringListEmptyEnd.
             [+] StringListAddFormat:     .
  02.03.2007 [*] TildeToAscii:         ASCII.
  23.02.2007 [+] IsTilde:     .
             [+] TildeToAscii:        ASCII.
  22.07.2006 [*] TransLatin:  .
  24.08.2005 [-] LeftString:  LeftStr  unit StrUtils.
  17.08.2005 [+] RightStringDelete:     .
  07.01.2005 [+] EmptyEndStringList:      .
             [+] TrimStringList:         .
  07.05.2004 [+] UpperFirstLetterWord:     ,  .
  23.01.2003 [-]  TAB.
  09.02.2002 [+] CharCount:      .
  26.09.2001 [+] ClearChars:      .
             [+]  .
  03.09.2001 [+] ReplaceStr:    .
             [+] EmptyCharString:     ,  .
  29.05.2001 [*] DeleteChars:    .
  19.11.2000 [*]      .
             [+]       .
  15.06.1999 [+]  .
  09.09.1998 [!]  Comming Library.

========================================================================================================================
  Copyright 19982020 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: CommingString.pas,v 1.27 2020/08/15 14:50:35 tsk Exp $
=======================================================================================================================}
unit CommingString;

interface

uses Windows, Classes, StrUtils,
     {$IFDEF VER150} // D7
     SysUtils, StdCtrls, Clipbrd,// DB,
     {$ELSE} // XE
     System.SysUtils, Vcl.StdCtrls,
     {$ENDIF}
     CommingOther;

  const
    TAB = #09;
    CRLF = #13#10;
    DigitChars = ['0'..'9'];
    Brackets = ['(', ')', '[', ']', '{', '}'];
    StdWordDelims = [#0..' ', ',' , '.' , ';', '/', '\', ':', '"', '`'] + Brackets;
    ClearChar = '"''()[]{}?!`';
    ClearInternetChar = ClearChar + ',.;/\:|&';
    DataDelims = '|';

  type
  TCaseMode = (cmUpper, cmLower, cmCaseInsensitive, cmDigit);

  // .
  function  DelChar( const S: String; Chr: Char ): String;
  function  DelDoubleChar( const S: string; Chr: Char ): string;
  function  DeleteChars( Source: String; Chars: String = ClearChar; DoubleChars: String = ' ' ): String;
  function  ClearChars( Source: String; Chars: String = ClearChar; ClearChar: Char = ' ' ): String;
  function  CharCount( C, S: String ): Integer;
  //  :
  function  NPos( C, S: string; N: Integer): Integer;
  function  PosChar( Chars, S: string; Offset: Cardinal = 1): Integer;
  function  PosAfter( Substr, S: String ): Integer;
  function  PosLast( Substr, S: String ): Integer;
  //
  function  Pad( InString: String; Len: Integer ): String;
  function  LPad( InString: String; Len: Integer ): String;
//function  Replicate( Ch: Char; Len: Integer ): String; -> System.StringOfChar
  function  Space( Len: Integer ): String;
//function  LeftString(InString: String; Len: Integer): String;  -> StrUtils.LeftStr
//function  RightString(InString: String; Len: Integer): String; -> StrUtils.RightStr
  //  :
  function  StrCheckSum(Text: String; Len: Integer): String;
  function  SwapLanguage(InString: String): String;
  function  GetBracketless(Value: String): String;
  //  :
  function  LeftStringDelete( InString: String; Len: Integer ): String;
  function  RightStringDelete( InString: String; Len: Integer ): String;
  function  CutLeftString( InString: String; Len: Integer ): String;
  function  CutLeftStringSubStr( Str, SubStr: String ): String;
  function  CutStringChar( InString, Char: String ): String;
  function  SubStringChar( InString, CharBegin, CharEnd: String ): String;
  //   :
  function  IsDataString( DataString: String ): Boolean;
  function  DataStringIndex( DataString: String; Index: Integer ): String;
  function  IncludeDataString( TestString, DataString: String ): Boolean;
  //
  function  SortString( sVal: String ): String ;
  // :
  function  MoneyToDigString( cMoney: Currency): String;
  function  CurrencyToStr( Value: Currency): String;
  // :
  function  DecodeParol( Parol: String ): String;
  function  EncodeParol( Parol: String ): String;
  function  ParolOscillator( Len: Integer = 8; CaseMode: TCaseMode = cmUpper ): String;
  //
  function  StrToHex( Str: String; Delim: String = '' ): String;
  function  HexToStr( Str: String): String;
  function  AddStringWithDelim( Base, Addition: String; Delim: String = ' ' ): String;
  function  TransRusLatin( Source: String ): String;
  function  TransRusLatinFamily( Source: String ): String;
  function  TransLatinRus( Source: String ): String;
{$IFDEF VER150} // D7
  function  StrToOem(const AnsiStr: String): String;
{$ENDIF}
  function  IsInRussian( Text: String ): Boolean;
  function  ReplaceStr( Str, Search, Replace: String ): String;
  function  EmptyCharString( Str: String; EmptyChars: TSysCharSet ): Boolean;
  function  UpperFirstLetterWord( Str: String): String;
  function  UpperFirstLetterSentence( Str: String): String;
  function  IsTilde( Text: String ): Integer;
  function  TildeToAscii( Str: String): String;
  function  ReplaceQuotation( Str: String): String;
  function  ReplaceBracket( Str: String): String;
  // :
  procedure ComboBoxItemSave( var ComboBox: TComboBox );
  procedure StringListTrim( var Text: TStringList );
  procedure StringListEmptyEnd( var Text: TStringList );
  procedure StringListEmptyDelete( var List: TStringList );
  procedure StringListAddFormat( List: TStringList; FormStr: String; const Args: array of const );
  procedure StringListAddList( Add: TStringList; var List: TStringList );
  procedure StringListTrimUpperFirstLetter( var Text: TStringList );
  function  StringListPos( Substr: String; List: TStringList ): Integer;
  //HTML:
  function HTMLDeleteComments( HTML: String ): String;
  function HTMLDeleteTag(HTML: String): String;
  function HTMLReplaceSymbol(HTML: String): String;
  // :
  function EncodeKey( Key: String; ID: Integer): String;
  function DecodeKeyObject( Key: String ): String;
  function DecodeKeyID( Key: String ): Integer;
  //    UNICODE.
  {$IFDEF VER150} // D7
  procedure PutStringIntoClipBoard (const Str: WideString);
  function  GetStringFromClipboard: WideString;
  function  AddStringFromClipboard ( Text: WideString; IsMemo: Boolean = True ): WideString;
//  procedure FieldAddClipboard( Field: TField );
  {$ENDIF}

implementation
//======================================================================================================================
function DelChar( const S: string; Chr: Char ): string;
  var i: Integer;
begin
  Result := S;
  for i := Length( Result ) downto 1 do
    if Result[i] = Chr
      then Delete( Result, i, 1 );
end;
//======================================================================================================================
function DelDoubleChar( const S: string; Chr: Char ): string;
  var i: Integer;
begin
  Result := S;
  for i := Length( Result ) downto 2 do
    if ( Result[ i ] = Chr ) and ( Result[ i - 1 ] = Chr ) then Delete( Result, i, 1 );
end;
//======================================================================================================================
function DeleteChars( Source, Chars, DoubleChars: String ): String;
  var i: Integer;
begin
  Result := Source;
  for i := 1 to Length( Chars ) do Result := DelChar( Result, Chars[i] );
  for i := 1 to Length( DoubleChars ) do Result := DelDoubleChar( Result, DoubleChars[i] );
end;
//======================================================================================================================
function ClearChars( Source, Chars: String; ClearChar: Char ): String;
  var i: Integer;
begin
  Result := Source;
  for i := 1 to Length( Result ) do begin
    if Pos( Result[i], Chars ) > 0 then Result[i] := ClearChar;
  end;
end;
//======================================================================================================================
function Pad( InString: String; Len: Integer ): String;
begin
  Result := Format( '%-*s', [Len, InString] );
end;
//======================================================================================================================
function LPad( InString: String; Len: Integer ): String;
begin
  Result := Format( '%*s', [Len, InString] );
end;
//======================================================================================================================
{  : }
//======================================================================================================================
function StrCheckSum( Text: String; Len: Integer ): String;
  var i, s, l: Integer;
begin
  s := 0;
  l := Length( Text );
  for i := 1 to l do s := s + Ord( Text[ i ]);
  Result := IntToHex( s, Len );
  l := Length( Result );
  if l > Len then Result := Copy( Result, l - Len + 1, Len );
end;
//======================================================================================================================
function SwapLanguage( InString: String ): String;
  var p: Integer;
begin
  Result := Trim( InString );
  if (InString = EmptyStr) then Exit;
  Result := StringReplace( Result, '(', '|', [ rfReplaceAll ]);
  Result := StringReplace( Result, '/', '|', [ rfReplaceAll ]);
  Result := StringReplace( Result, ')', '', [ rfReplaceAll ]);
  p := Pos ( '|', Result );
  if p > 0
    then Result := Trim( Copy( Result, p + 1, MaxInt )) + ' (' + Trim( Copy( Result, 1, p - 1)) + ')'
    else Result := InString;
end;
//======================================================================================================================
function GetBracketless(Value: String): String;
begin
  Result := Value;
  if Pos( '(', Value ) > 0 then Result := Trim( Copy( Value, 1 , Pos( '(', Value ) - 1));
end;
//======================================================================================================================
{  : }
//======================================================================================================================
function  LeftStringDelete(InString: String; Len: Integer): String;
begin
  Result := Copy( InString, Len + 1, MaxInt);
end;
//======================================================================================================================
function  RightStringDelete(InString: String; Len: Integer): String;
begin
  Result := Copy( InString, 1, Length( InString ) - Len );
end;
//======================================================================================================================
function  CutLeftString(InString: String; Len: Integer): String;
begin
  Result := Copy( InString, Len + 1, Length( InString ) - Len );
end;
//======================================================================================================================
function  CutLeftStringSubStr( Str, SubStr: String ): String;
  var p: Integer;
begin
  Result := Str;
  p := Pos( SubStr, Result );
  if (p > 0) then Result := Copy( Result, p + Length( SubStr ), MaxInt );
end;
//======================================================================================================================
function  CutStringChar( InString, Char: String ): String;
  var p: Integer;
begin
  Result := InString;
  p := Pos( Char, Result );
  if (p > 0) then Result := Trim( Copy( Result, 1, p - 1 ));
end;
//======================================================================================================================
function  SubStringChar( InString, CharBegin, CharEnd: String ): String;
  var p: Integer;
begin
  Result := InString;
  p := Pos( CharBegin, Result );
  if (p > 0) then Result := Trim( Copy( Result, p + 1, MaxInt ));
  p := Pos( CharEnd, Result );
  if (p > 0) then Result := Trim( Copy( Result, 1, p - 1 ));
end;
//======================================================================================================================
{   : }
//======================================================================================================================
function  IsDataString( DataString: String ): Boolean;
begin
  Result := ( DataString <> EmptyStr ) and ( DataString[1] = DataDelims );
end;
//======================================================================================================================
{function CutDataString( var DataString: String ): String;
  var p: Integer;
begin
  Result := EmptyStr;
  if DataString = EmptyStr then Exit;
  if (DataString[1] = DataDelims) then DataString := Copy( DataString, 2, MaxInt );
  p := Pos( DataDelims, DataString );
  if ( p > 0 ) then begin
    Result      := Copy( DataString, 1, p - 1 );
    DataString  := Copy( DataString, p + 1, MaxInt );
  end else begin
    Result      := EmptyStr;
    DataString  := EmptyStr;
  end;
end;}
//======================================================================================================================
function  DataStringIndex( DataString: String; Index: Integer ): String;
  var i, p: Integer;
      t: String;
begin
  if IsDataString( DataString ) then begin
    t := Copy( DataString, 2, MaxInt );
  end else begin
    Result := EmptyStr;
    Exit;
  end;
  for i := 1 to Index do begin
    p := Pos( DataDelims, t);
    Result := Copy( t, 1, p - 1 );
    t := Copy( t, p + 1, MaxInt );
  end;
end;
//======================================================================================================================
function IncludeDataString( TestString, DataString: String ): Boolean;
  var i: Integer;
      s: String;
begin
  if IsDataString( DataString ) then begin
    Result := False;
    i := 1;
    repeat
      s := DataStringIndex( DataString, i );
      if ( s <> EmptyStr ) then Result := Result or ( Pos( s, TestString ) > 0 );
      Inc( i );
    until ( s = EmptyStr );
  end else begin
    Result := ( Pos( DataString, TestString ) > 0 );
  end;
end;
//======================================================================================================================
//
//======================================================================================================================
function Space( Len: Integer ): String;
begin
  Result := StringOfChar( #32, Len );
end;
//======================================================================================================================
function Empty(InString: string): boolean;
begin
  Result := ( Length( InString ) = 0 ) or ( Trim( InString ) = '' );
end;
//======================================================================================================================
function SortString( sVal: String ): String ;
  var lRepit: Boolean;
      iLen, i: Integer;
      b: Char;
      x: String;
begin
  x := sVal; iLen := Length( sVal ) - 1;
  repeat
    lRepit := False;
    for i := 1 to iLen do
      if x[ i ] > x[ i + 1 ] then
        begin
          lRepit := True;
          b := x[ i ]; x[ i ] := x[ i + 1 ]; x[ i + 1 ] := b;
        end;
  until not lRepit;
  Result := x;
end;
//======================================================================================================================
function MoneyToDigString( cMoney: Currency): String;
  var p: Integer;
begin
  Result := Trim( FormatFloat( '### ### ### ##0.00', cMoney ));
  p := Pos( ',', Result );
  Delete( Result, p, 1 );
  Insert( ' . ', Result, p );
  Result := Result + ' .';
end;
//======================================================================================================================
function CurrencyToStr( Value: Currency ): String;
begin
  Result := Trim( FormatFloat( '### ### ### ##0.00', Value ));
{$IFDEF VER150} // D7
  Result := Result + CurrencyString;
{$ELSE} // XE
  Result := Result + FormatSettings.CurrencyString;
{$ENDIF}
end;
//======================================================================================================================
function DecodeParol( Parol: String ): String;
  var i, xChar: Integer;
begin
  Parol   := Pad( Parol, 20 );
  Result  := '';
  for i := 9 downto 0 do begin
    xChar := StrToIntDef( '$' + Copy( Parol, i * 2 + 1, 2 ), 32 );
    if xChar <= 32 then xChar := 32;
    Result := Result + Chr( xChar );
  end;
  Result := Trim( Result );
end;
//======================================================================================================================
function EncodeParol( Parol: String ): String;
  var i, xChar: Integer;
begin
  Parol   := Pad( Parol, 10 );
  Result  := '';
  Randomize;
  for i := 10 downto 1 do begin
    xChar := Ord( Parol[i]);
    if xChar = 32 then xChar := Random( 32 );
    Result := Result + IntToHex( xChar, 2 );
  end;
end;
//======================================================================================================================
function  ParolOscillator( Len: Integer; CaseMode: TCaseMode ): String;
  var i: Integer;
      lt: String;
begin
  Result := '';
  Randomize;
  if CaseMode = cmDigit then Len := 4;
  for I := 1 to Len do begin
    lt := '';
    while ( lt = '') do begin
      case CaseMode of
        cmUpper:            lt := Chr( Random( 40 ) + 50 );
        cmLower:            lt := Chr( Random( 26 ) + 97 );
        cmCaseInsensitive:  lt := Chr( Random( 72 ) + 50 );
        cmDigit:            lt := Chr( Random( 8 ) + 50 );
      end;
      if Pos ( lt, ':;<=>?@0QWIO[\]^`_ijloq' + Result ) > 0 then lt := '';
    end;
    Result := Result + lt;
  end;
end;
//======================================================================================================================
function StrToHex( Str: String; Delim: String = '' ): String;
  var i: Integer;
begin
  Result := '';
  for i:= 1 to Length( Str) do begin
    if ( Result <> '' ) and ( Delim <> '' ) then Result := Result + Delim;
    Result := Result + IntToHex( Ord ( Str[i]), 2 )
  end;
end;
//======================================================================================================================
function HexToStr( Str: String): String;
  var i: Integer;
begin
  Result := '';
  for i:= 0 to ( Length( Str) div 2 ) - 1
    do Result := Result + Chr( StrToInt( '$' + Copy( Str, i * 2 + 1, 2 )));
end;
//======================================================================================================================
function AddStringWithDelim( Base, Addition, Delim: String ): String;
begin
  if Empty( Addition )
    then Result := Base
    else Result := iif ( Empty( Base ),
                         Addition,
                         Base + iif( Delim = ' ', Delim, Delim + ' ') + Addition );
end;
//======================================================================================================================
function TransRusLatin( Source: String ): String;
  var i: Integer;
  const Latin: array [1..64] of String
    = (  'A',  'B',  'V',  'G',  'D',  'E', 'Zh',  'Z',  'I',  'J',  'K',  'L',  'M',  'N',  'O',
     //                                                                         
         'P',  'R',  'S',  'T',  'U',  'F',  'H', 'Ts', 'Ch', 'Sh','Sch','''',   'Y','''',   'E',
     //                                                                         
        'Yu', 'Ya',  'a',  'b',  'v',  'g',  'd',  'e', 'zh',  'z',  'i',  'j',  'k',  'l',  'm',
     //                                                                         
         'n',  'o',  'p',  'r',  's',  't',  'u',  'f',  'h', 'ts', 'ch', 'sh','sch', '''',  'y',
     //                                                                         
        '''',  'e', 'yu', 'ya' );
     //                  
begin
  Result := '';
  for i := 1 to Length( Source ) do
    if Source[i] >= ''
      then Result := Result + Latin[ Ord( Source[i]) - 191 ]
      else if (Ord( Source[i]) = 168) then Result := Result + 'Io'
      else if (Ord( Source[i]) = 184) then Result := Result + 'io'
      else Result := Result + Source[i];
end;
//======================================================================================================================
function  TransRusLatinFamily( Source: String ): String;
  var i: Integer;
  const Latin: array [1..63, 1..2] of string = (
    ( '', 'vy'   ),
    ( '', 'gy'   ),
    ( '', 'dy'   ),
    ( '', 'ny'   ),
    ( '', 'sy'   ),
    ( '', 'ty'   ),
    ( '',  'zd'   ),
    ( '',  'ay'   ),
    ( '',  'ey'   ),
    ( '',  'ey'   ),
    ( '',  'iy'   ),
    ( '',  'ia'   ),
    ( '',  'oy'   ),
    ( '',  'uy'   ),
    ( '',  'uy'   ),
    ( '',  'ey'   ),
    ( '',  'ia'   ),
    ( '',  'ye'   ),
    ( '',  'ye'   ),
    ( '',  'ia'   ),
    ( '',  'yi'   ),
    ( '',  'yo'   ),
    ( '',  'yu'   ),
    ( '',  'yy'   ),
    ( '',  'ye'   ),
    ( '',  'yu'   ),
    ( '',  'x'    ),
    ( '',  'yuy'  ),
    ( '',  'yay'  ),
    ( '',  'liu'  ),
    ( '',   'zh'   ),
    ( '',   'kh'   ),
    ( '',   'ts'   ),
    ( '',   'ch'   ),
    ( '',   'sh'   ),
    ( '',   'ya'   ),
    ( '',   'yu'   ),
    ( '',   'shch' ),
    ( '',   ''     ),
    ( '',   ''     ),
    ( '',   'a'    ),
    ( '',   'b'    ),
    ( '',   'v'    ),
    ( '',   'g'    ),
    ( '',   'd'    ),
    ( '',   'e'    ),
    ( '',   'e'    ),
    ( '',   'z'    ),
    ( '',   'i'    ),
    ( '',   'y'    ),
    ( '',   'k'    ),
    ( '',   'l'    ),
    ( '',   'm'    ),
    ( '',   'n'    ),
    ( '',   'o'    ),
    ( '',   'p'    ),
    ( '',   'r'    ),
    ( '',   's'    ),
    ( '',   't'    ),
    ( '',   'u'    ),
    ( '',   'f'    ),
    ( '',   'y'    ),
    ( '',   'e'    )
    );
begin
  Result := AnsiLowerCase( Source );
  for i := 1 to High( Latin )
    do Result := StringReplace( Result, Latin[ i, 1 ], Latin[ i, 2], [ rfReplaceAll ]);
  Result := UpperFirstLetterWord( Result );
end;
//======================================================================================================================
function TransLatinRus( Source: String ): String;
  var i: Integer;
  const Latin: array [1..58] of String
    = ( '','','','','','','','','','','','','','','','','?','','','','',
     //  A   B   C   D   E   F   G   H   I   J   K   L   M   N   O   P   Q   R   S   T   U
        '','?','?','','','?','?','?','?','?','?',
     //  V   W   X   Y   Z
        '','','','','','','','','','','','','','','','','?','','','','',
     //  A   B   C   D   E   F   G   H   I   J   K   L   M   N   O   P   Q   R   S   T   U
        '','?','?','','' );
     //  V   W   X   Y   Z
         ManyLat: array [0..31] of String
     = ( 'Sch', '',
         'sch', '',
         'Ch',  '',
         'ch',  '',
         'Zh',  '',
         'zh',  '',
         'Ts',  '',
         'ts',  '',
         'Sh',  '',
         'sh',  '',
         'Yu',  '',
         'yu',  '',
         'Ya',  '',
         'ya',  '',
         'Ja',  '',
         'ja',  ''
          );
begin
  for i := 0 to 15 do
    Source := StringReplace( Source, ManyLat[i*2], ManyLat[i*2+1], [rfReplaceAll]);
  Result := '';
  for i := 1 to Length( Source ) do
    if ( Source[i] >= 'A' ) and ( Source[i] <= 'z' )
      then Result := Result + Latin[ Ord( Source[i]) - 64 ]
      else Result := Result + Source[i];
end;
//======================================================================================================================
function  IsInRussian( Text: String ): Boolean;
  var i: Integer;
begin
  Result := False;
  for i := 1 to Length( Text ) do
    if Ord( Text[i] ) >= 192 then begin
      Result := True;
      Exit;
    end;
end;
//======================================================================================================================
{$IFDEF VER150} // D7
function StrToOem(const AnsiStr: String): String;
begin
  SetLength(Result, Length(AnsiStr));
  if Length(Result) > 0 then
    CharToOemBuff(PChar(AnsiStr), PChar(Result), Length(Result));
end;
{$ENDIF}
//======================================================================================================================
function ReplaceStr( Str, Search, Replace: String ): String;
  var i: Integer;
      Source: string;
begin
  Source := Str;
  Result := '';
  repeat
    i:= Pos( Search, Source );
    if i > 0 then begin
      Result := Result + Copy( Source, 1, i - 1 ) + Replace;
      Source := Copy( Source, i + Length( Search ), MaxInt );
    end else begin
      Result := Result + Source;
    end;
  until i <= 0;
end;
//======================================================================================================================
function EmptyCharString( Str: String; EmptyChars: TSysCharSet ): Boolean;
  var i: Integer;
begin
  for i := 1 to Length( Str ) do
{$IFDEF VER150} // D7
    if not ( Str[I] in EmptyChars ) then begin
{$ELSE} // XE
    if not CharInSet( Str[I], EmptyChars ) then begin
{$ENDIF}
      Result := False;
      Exit;
    end;
  Result := True;
end;
//======================================================================================================================
function CharCount( C, S: String ): Integer;
  var i: Integer;
begin
  Result := 0;
  for i := 1 to Length(S) do if S[i] = C then Inc( Result );
end;
//======================================================================================================================
function NPos( C, S: string; N: Integer): Integer;
  var I, P, K: Integer;
begin
  Result := 0;
  K := 0;
  for I := 1 to N do begin
    P := Pos(C, S);
    Inc(K, P);
    if (I = N) and (P > 0) then begin
      Result := K;
      Exit;
    end;
    if P > 0 then Delete(S, 1, P)
    else Exit;
  end;
end;
//======================================================================================================================
function PosChar( Chars, S: string; Offset: Cardinal = 1): Integer;
  var i: Integer;
begin
  Result := 0;
  for i := 1 to length( S ) do
    if Pos( S[i], Chars ) > 0 then begin
      Result := i; Exit;
    end;
end;
//======================================================================================================================
function PosAfter( Substr, S: String ): Integer;
begin
  Result := Pos( Substr, S );
  if Result > 0 then Result := Result + Length( Substr );
end;
//======================================================================================================================
function  PosLast( Substr, S: String ): Integer;
  var p: Integer;
begin
  Result := Pos( Substr, S );
  if Result < 0 then Exit;
  repeat
    p := Result + 1;
{$IFDEF VER150} // D7
    p := PosEx( Substr, S, p );
{$ELSE} // XE
    p := Pos( Substr, S, p );
{$ENDIF}
    if (p > 0) then Result := p
  until (p = 0);
end;
//======================================================================================================================
function UpperFirstLetterWord( Str: String): String ;
  var i: Integer;
      u: Boolean;
begin
  Result := AnsiLowerCase( Str );
  u := True;
  for i := 1 to Length( Result ) do begin
{$IFDEF VER150} // D7
    if ( Result[i] in StdWordDelims + [ '-', '', '' ] )
{$ELSE} // XE
    if CharInSet( Result[i], StdWordDelims + [ '-', '', '' ])
{$ENDIF}
      then u := True
      else if u then begin Result[i] := AnsiUpperCase(Result[i])[1]; u := False end;
  end;
end;
//======================================================================================================================
function UpperFirstLetterSentence( Str: String): String;
  var i: Integer;
begin
  Result := AnsiLowerCase( Str );
  Result[1] := AnsiUpperCase(Result[1])[1];
  for i := 1 to Length( Result ) do if ( Result[i] = '.' ) then Result[i + 2] := AnsiUpperCase(Result[i + 2])[1];
end;
//======================================================================================================================
function  IsTilde( Text: String ): Integer;
  var i: Integer;
begin
  Result := -1;
  for i := 1 to Length( Text ) do
    if ( Text[i] >= #$7E ) then begin Result := i; Exit; end;
end;
//======================================================================================================================
function TildeToAscii( Str: String): String ;
  var i, p: Integer;
  const sTilde = #$60+
                 #$8E+
                 #$9A+
                 #$C0#$C1#$C2#$C3#$C4#$C5#$C6#$C7#$C8#$C9#$CA#$CB#$CC#$CD#$CE#$CF+
                 #$D6+#$DC+
                 #$E0#$E1#$E2#$E3#$E4#$E5#$E6#$E7#$E8#$E9#$EA#$EB#$EC#$ED#$EE#$EF+
                 #$F0#$F1#$F2#$F3#$F4#$F5#$F6#$F7#$F8#$F9#$FA#$FB#$FC#$FD#$FE#$FF;
        sASCII = #$27+
                 #$5A+
                 #$73+
                 #$41#$41#$41#$41#$41#$41#$C6#$43#$45#$45#$45#$45#$49#$49#$49#$49+
                 #$4f+#$55+
                 #$61#$61#$61#$61#$61#$61#$E6#$63#$65#$65#$65#$65#$69#$69#$69#$69+
                 #$F0#$6E#$6F#$6F#$6F#$6F#$6F#$F7#$6F#$75#$75#$75#$75#$79#$70#$79;
  procedure RP( var Str: String; Sub: String; Pos: Integer );
  begin
   Delete( Str, Pos, 1 );
   Insert( Sub, Str, Pos );
  end;
begin
  Result := Str;
  for i := 1 to Length( Str ) do begin
    p := Pos( Result[i], sTilde );
    if p > 0 then Result[i] := sASCII[p];
    case Result[i] of
      #$E6: RP( Result, 'ae',   i );
      #$C6: RP( Result, 'Ae',   i );
      #$DF: RP( Result, 'ss',   i );
    end;
  end;
end;
//======================================================================================================================
function ReplaceQuotation( Str: String ): String;
begin
  Result := Str;
  if LeftStr( Result, 1) = '''' then Result := LeftStringDelete( Result, 1 );
  if RightStr( Result, 1) = '''' then Result := RightStringDelete( Result, 1);
  //  :
  Result := ClearChars( Result, '"' );
  //   :
  Result := '' + Trim( Result ) + '';
end;
//======================================================================================================================
function ReplaceBracket( Str: String): String;
begin
  Result := Str;
  Result := StringReplace( Result, '[', '(', [ rfReplaceAll ]);
  Result := StringReplace( Result, ']', ')', [ rfReplaceAll ]);
end;
//======================================================================================================================
{  }
//======================================================================================================================
procedure ComboBoxItemSave( var ComboBox: TComboBox );
  var ss: String;
      p: Integer;
begin
  ss := ComboBox.Text;
  if ss = EmptyStr then Exit;
  with ComboBox do begin
    p := Items.IndexOf( ss );
    if p < 0
      then Items.Insert( 0, ss )
      else Items.Move( p, 0);
    while Items.Count > DropDownCount do Items.Delete( Items.Count - 1 );
    ItemIndex := Items.IndexOf( ss );
  end;
end;
//==================================================================================================================
procedure StringListTrim( var Text: TStringList );
  var i: Integer;
begin
  for i := 0 to Text.Count - 1 do Text[i] := Trim( Text[i] )
end;
//======================================================================================================================
procedure StringListTrimUpperFirstLetter( var Text: TStringList );
  var i: Integer;
begin
  for i := 0 to Text.Count - 1
    do if Length(Text[i])> 0
        then Text[i] :=  AnsiUpperCase(Text[i][1]) + Copy( Text[i], 2, Length(Text[i]));
end;
//======================================================================================================================
procedure StringListEmptyEnd( var Text: TStringList );
begin
  while ( Text.Count > 0 ) and ( Length( Text[Text.Count-1] ) = 0 )
    do Text.Delete(Text.Count-1);
end;
//======================================================================================================================
procedure StringListEmptyDelete( var List: TStringList );
  var i: Integer;
begin
  i := 0;
  while i < List.Count do
    if ( List[i] = EmptyStr ) then begin
      List.Delete( i );
      i := 0;
    end else Inc( i );
end;
//======================================================================================================================
procedure StringListAddFormat( List: TStringList; FormStr: String; const Args: array of const );
begin
  List.Add( Format( FormStr, Args ));
end;
//======================================================================================================================
procedure StringListAddList( Add: TStringList; var List: TStringList );
  var i: Integer;
begin
  for i := 0 to Add.Count - 1 do if List.IndexOf( Add[i] ) < 0 then List.Add( Add[i] );
end;
//======================================================================================================================
function StringListPos( Substr: String; List: TStringList ): Integer;
  var i: Integer;
begin
  Result := -1;
  for i := 0 to List.Count - 1 do begin
    if Pos( Substr, List[i] ) > 0 then Result := i;
  end;
end;
//======================================================================================================================
{ HTML }
//======================================================================================================================
function HTMLDeleteComments( HTML: String ): String;
  var p0, p1: Integer;
begin
  while Pos( '<!--', HTML ) > 0 do begin
    p0 := Pos( '<!--', HTML );
    p1 := Pos( '-->', HTML );
    HTML := Copy( HTML, 1, p0 - 1) + Copy( HTML, p1 + 3, MaxInt )
  end;
  Result := HTML;
end;
//======================================================================================================================
function HTMLDeleteTag( HTML: String ): String;
  var p0, p1: Integer;
begin
  while Pos( '<', HTML ) > 0 do begin
    p0 := Pos( '<', HTML );
    p1 := Pos( '>', HTML );
    HTML := Copy( HTML, 1, p0 - 1) + Copy( HTML, p1 + 1, MaxInt )
  end;
  Result := HTML;
end;
//======================================================================================================================
function HTMLReplaceSymbol(HTML: String): String;
begin
  HTML := StringReplace( HTML, '&nbsp;', #160, [ rfReplaceAll, rfIgnoreCase ]);
  Result := HTML;
end;
//======================================================================================================================
{  }
function EncodeKey( Key: String; ID: Integer): String;
begin
  Result := Key + IntToStr( ID);
end;
function DecodeKeyObject( Key: String ): String;
begin
  Result := Copy( Key, 1, 1 );
end;
function DecodeKeyID( Key: String ): Integer;
begin
  Result := StrToInt( Copy( Key, 2, MaxInt ));
end;
//======================================================================================================================
{$IFDEF VER150} // D7
procedure PutStringIntoClipBoard(const Str: WideString);
var
  Size: Integer;
  Data: THandle;
  DataPtr: Pointer;
begin
  Size := Length(Str);
  if Size = 0 then
    exit;
  if not IsClipboardFormatAvailable(CF_UNICODETEXT) then
    Clipboard.AsText := Str
  else
  begin
    Size := Size shl 1 + 2;
    Data := GlobalAlloc(GMEM_MOVEABLE + GMEM_DDESHARE, Size);
    try
      DataPtr := GlobalLock(Data);
      try
        Move(Pointer(Str)^, DataPtr^, Size);
        Clipboard.SetAsHandle(CF_UNICODETEXT, Data);
      finally
        GlobalUnlock(Data);
      end;
    except
      GlobalFree(Data);
      raise;
    end;
  end;
end;
//======================================================================================================================
function GetStringFromClipboard: WideString;
var
  Data: THandle;
begin
  if not IsClipboardFormatAvailable(CF_UNICODETEXT) then
    Result := Clipboard.AsText
  else
  begin
    Clipboard.Open;
    Data := GetClipboardData(CF_UNICODETEXT);
    try
      if Data <> 0 then
        Result := PWideChar(GlobalLock(Data))
      else
        Result := '';
    finally
      if Data <> 0 then
        GlobalUnlock(Data);
      Clipboard.Close;
    end;
  end;
end;
//======================================================================================================================
function AddStringFromClipboard( Text: WideString; IsMemo: Boolean ): WideString;
begin
  Result := GetStringFromClipboard;
  if not ( Text = EmptyStr) then begin
    if IsMemo
      then Text := Text + CRLF
      else Text := Text + ' ';
    Result := Text + '& ' + Result;
  end;
end;
//======================================================================================================================
{procedure FieldAddClipboard( Field: TField );
  var c: String;
begin
  c := GetStringFromClipboard;
  if not ( Field.DataSet.State in [ dsEdit, dsInsert ]) then Field.DataSet.Edit;
  if not ( c = EmptyStr) then
    if Field.Text = EmptyStr
      then Field.Text := c
      else Field.Text := Field.Text + ' & ' + c;
end;}{$ENDIF}
//======================================================================================================================
end.
